/*
  $Id: MemImpl.h,v 1.2 2016/08/27 07:55:03 ewan Exp $
  Abstract memory implementation.
  MemImpl.h (C) 2016 Ewan Parker.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  The author may be reached at http//www.ewan.cc/ for queries.
*/

#ifndef MemImpl_H
#define MemImpl_H

class MemImpl
{
public:
  // Total size of the memory.
  virtual uint32_t getMemSize() = 0;

  // Page boundary mask for alignment of page reads and writes.
  virtual uint8_t getBoundaryMask() = 0;

  // Read a block from memory at address mem to *data with length len.
  virtual void readBlock(void *data, uint32_t mem, uint8_t len);

  // Write a block to memory at address mem from *data with length len.
  virtual void writeBlock(void *data, uint32_t mem, uint8_t len);
};

#endif
