/*
  $Id: MemImplATMEGA328PEEPROM.cpp,v 1.2 2016/08/27 07:55:03 ewan Exp $
  ATMEGA328P internal EEPROM specific memory implementation.
  MemImplATMEGA328PEEPROM.cpp (C) 2016 Ewan Parker.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  The author may be reached at http//www.ewan.cc/ for queries.
*/

#include <Arduino.h>
#include <MemImplATMEGA328PEEPROM.h>
#include <avr/eeprom.h>

// Total size of the memory.  1kB for ATMEGA328P internal EEPROM.
uint32_t MemImplATMEGA328PEEPROM::getMemSize()
{
  return 1024;
}

// Page boundary mask for alignment of page reads and writes.  32 bits for
// ATMEGA328P internal EEPROM.
uint8_t MemImplATMEGA328PEEPROM::getBoundaryMask()
{
  return 0x03;
}

// Read a block from memory at address mem to *data with length len.
void MemImplATMEGA328PEEPROM::readBlock(void *data, uint32_t mem, uint8_t len)
{
  eeprom_read_block(data, (void *)mem, len);
}

// Write a block to memory at address mem from *data with length len.
void MemImplATMEGA328PEEPROM::writeBlock(void *data, uint32_t mem, uint8_t len)
{
  eeprom_write_block(data, (void *)mem, len);
}
